%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%define perlver %(eval "`%{__perl} -V:version`"; echo $version)

Name:           perl-Tk
Version:        804.028
Release:        13.ru6
Summary:        Perl Graphical User Interface ToolKit

Group:          Development/Libraries
License:        GPL+ or Artistic
URL:            http://search.cpan.org/dist/Tk/
Source0:        http://cpan.org/modules/by-module/Tk/Tk-804.028.tar.gz
Patch0:         perl-Tk-widget.patch
# modified version of http://ftp.de.debian.org/debian/pool/main/p/perl-tk/perl-tk_804.027-8.diff.gz
Patch1:         perl-Tk-debian.patch.gz
# fix segfaults as in #235666 because of broken cashing code
Patch2:         perl-Tk-seg.patch
# fix interaction with XIM, bug #489228, upstream change r12589
Patch3:		perl-Tk-XIM.patch
# fix for bugs #491536 & #489228 & #506496 (see comment #8)
# see http://rt.cpan.org/Public/Bug/Display.html?id=38746
Patch4:		perl-Tk-events.patch
# fix for bug #487122
# see http://rt.cpan.org/Public/Bug/Display.html?id=31989
Patch5:         perl-Tk-getOpenFile.patch

# fix gif overflow in tk see CVE-2006-4484 and CVE-2007-6697 or #431518 and
# #431529
Patch100:       perl-Tk-gif.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


BuildRequires:  perl perl-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpng-devel
BuildRequires:  libX11-devel
BuildRequires:  libXft-devel

Requires:       perl(:MODULE_COMPAT_%{perlver})
Provides:       perl(Tk::LabRadio) = 4.004
Provides:       perl(Tk::TextReindex)
Provides:       perl(Tk) = %{version}

%description
This a re-port of a perl interface to Tk8.4.
C code is derived from Tcl/Tk8.4.5.
It also includes all the C code parts of Tix8.1.4 from SourceForge.
The perl code corresponding to Tix's Tcl code is not fully implemented.

Perl API is essentially the same as Tk800 series Tk800.025 but has not
been verified as compliant. There ARE differences see pod/804delta.pod.

%prep
%setup -q -n Tk-%{version}
find . -type f -exec %{__perl} -pi -e \
's,^(#!)(/usr/local)?/bin/perl\b,$1%{__perl}, if ($. == 1)' {} \;
chmod -x pod/Popup.pod Tixish/lib/Tk/balArrow.xbm
# fix for widget as docs
%patch0
%{__perl} -pi -e \
's,\@demopath\@,%{_datadir}/doc/%{name}-%{version}/demos,g' \
%{_builddir}/Tk-%{version}/demos/widget
# debian patch
%patch1 -p1
# patch to fix #235666 ... seems like caching code is broken
%patch2 -p1 -b .seg
%patch3 -p1 -b .xim
%patch4 -b .events
%patch5 -b .getOpenFile
%patch100

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor X11LIB=%{_libdir} XFT=1
find . -name Makefile | xargs %{__perl} -pi -e 's/^\tLD_RUN_PATH=[^\s]+\s*/\t/'
make %{?_smp_mflags}

# disable because they need an x screen
%check
# make test

%install
rm -rf $RPM_BUILD_ROOT

make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -exec rm -f {} \;
find $RPM_BUILD_ROOT -type d -depth -exec rmdir {} 2>/dev/null \;

chmod -R u+rwX,go+rX,go-w $RPM_BUILD_ROOT/*
mkdir __demos
cp -pR $RPM_BUILD_ROOT%{perl_vendorarch}/Tk/demos __demos
find __demos/ -type f -exec chmod -x {} \;

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc Changes README README.linux ToDo pTk/*license* __demos/demos demos/widget
%doc blib/man1/widget.1
%{_bindir}/p*
%{_bindir}/tkjpeg
%{perl_vendorarch}/auto/Tk
%{perl_vendorarch}/T*
%{_mandir}/man*/*
%exclude %{_mandir}/man1/widget.1*
%exclude %{_bindir}/gedi
%exclude %{_bindir}/widget
%exclude %{perl_vendorarch}/fix_4_os2.pl
%exclude %{perl_vendorarch}/Tk/demos
%exclude %{perl_vendorarch}/Tk/reindex.pl

%changelog
* Fri Sep 09 2011 Russ Frank <rfranknj@nbcs.rutgers.edu> - 804.028-13.ru6
- Rutgers build for Centos 6
- adding dep on perl-devel

* Mon Feb 22 2010 Orcan Ogetbil <orcan@nbcs.rutgers.edu> - 804.028-12
- Centos port. systemimager-server needs it.

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 804.028-11
- rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 804.028-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

